# dartmagur [![Pub](https://img.shields.io/pub/v/dartmagur.svg)](https://pub.dartlang.org/packages/dartmagur) [![documentation](https://img.shields.io/badge/Documentation-dartmagur-yellow.svg)](https://www.dartdocs.org/documentation/dartmagur/latest/)

[Imagur](https://imgur.com) library for dart.

## Docs

### Dartdocs

[Dartdocs]()

### Documentation

[Dartmagur]() class is main point of library. For now you can initialize it only with `clientId`. 
Library don't supports `POST` endpoints - Work in Progress.

```dart
var dartmagur = new Dartmagur("<YOU CLIENT ID>");
```

From there you have few options

#### Get Album

```dart
Future<Album> getAlbum(String id);
```
 * `id` - id of album
 
#### Get Galleries

This endpoint returns list of Imagur's galleries. Results can be filtered with optional parameters.

```dart
Future<List<Gallery>> getGalleries
  ({String section: "hot", String sort: "viral", int page: 0, 
    String window: "day", bool showViral: true, bool mature: true})
```
 * `section` - Section to where search for gallery. `hot | top | user. Defaults to hot`
 * `sort` -  How to sort results. `viral | top | time | rising (only available with user section). Defaults to viral`
 * `page` - page number
 * `window` - Change the date range of the request if the section is top. `Accepted values are day | week | month | year | all. Defaults to day`
 
 
#### Get Gallery

Gets gallery based on given id

```dart
 Future<Gallery> getGallery(String id)
```
 * `id` - Gallery id
 
#### Get Subreddit

Gets list of images on subreddit

```dart
 Future<List<Image>> getSubreddit(String id, {String sort: "time", int page: 0, String window: "week"})
```
 * `id` - id of subreddit
 * `sort` - How to sort results. `viral | top | time | rising (only available with user section). Defaults to viral`
 * `page` - page number
 * `window` - Change the date range of the request if the section is top. `Accepted values are day | week | month | year | all. Defaults to day`
 
#### Search for gallery

Searches for Gallery with list fo keywords.

```dart
Future<List<Gallery>> searchGallery(List<String> query, {String sort: "time", String window: "all", int page: 0})
```
 * `query` - list of keywords. All keywords are automatically ORed.
 * `sort` -  How to sort results. `viral | top | time | rising (only available with user section). Defaults to viral`
 * `page` - page number
 * `window` - Change the date range of the request if the section is top. `Accepted values are day | week | month | year | all. Defaults to day`